# Migrator Change Log

11/2/2020 6:50:42 AM


**Version 2.2.1**
* [feature]  Added support for duplicating a migration file. This is useful for vertical apps that deploy the same file multiple times on the same server.
* [feature]  Migrations can now be executed on any server.
* [feature]  Post-migration scripts can now be executed on any server.
* [bug]  If the file name on the "to" server was different from the "from" server, the additional options (i.e., ignore accounts, ignore value lists, ignore fonts) would default to true.
* [bug]  Files in the Saved Folder were being overwritten despite option to "don't overwrite existing saved files" selected.

**Version 2.2.0**
* [feature]  Changed name from Otto Migrator to Migrator (file name changed from Otto Migrator V2.fmp12 to Migrator.fmp12).
* [feature]  Allow for Saved Folder migrations using clones/copies previously saved.
* [bug]  The script name Get Files from Otto { ServerId, Active } could cause confusion since it might be interpreted to mean download files. It has been changed to Get File Information from Otto { ServerId, Active }.

**Version 2.1.1**
* [feature]  Improvements to new server wizard for FMS 19 compatibility
* [feature]  Added a popover on the Migration Summary slide that shows a portal of the files in this migration. It shows the file name "from" and "to," and allows the "to" name to be edited. Thanks to Stephen Dolenski.
* [feature]  Added button to open the Otto console (i.e., web app) from server details. Thanks to Stephen Dolenski.
* [feature]  Elapsed time field in migration history is now stored and displayed as time (i.e., hh:mm:ss) instead of seconds.
* [feature]  Added value list to select file for post-migration script.
* [feature]  Lots of timing and workflow improvemements for batch migrations.
* [bug]  Deleting a migration record failed to delete related data (e.g., history).
* [bug]  Delete history button wasn't deleting the history record.
* [bug]  If an error occurred while updating server version info the response indicated that it completed succcessfully.
* [bug]  cURL connect-timeout options weren't being honored.
* [bug]  Resolved minor UI issues on Migrations layout 
* [bug]  Resolved record-locking issues with migration file picker.
* [bug]  We're no longer treating a timeout error the same as a migration error.
* [bug]  Updated for compatibility with FMS 19 for scheduling migrations and running post-migration scripts.
* [bug]  Batch migrations and scheduled migrations were not storing the correct value in the last migration result field, which prevented the correct icon from showing up in the migration found set portal.
* [bug]  Encrypted files being sent as copies wouldn't open automatically because the encryption key was only being sent in migration requests.
* [bug]  Schedule details— buttons at bottom weren't pinned properly.
* [bug]  Post-migration script schedules failed if Otto Migrator wasn't on the destination server.

**Version 2.1.0**
* [feature]  Minor script organization
* [feature]  New script "Start Attended Migration" allows migrations to be run from other files; only display the progress dialog. This replaces the old Start Migration public script.
* [bug]  Downloading a copy of the file(s) after a migration will use the file name from the destination server if it's different from the file on the "from" server.
* [bug]  Opening server-specific file names was showing the properties (e.g., file name) for the last migration opened from that session.

**Version 2.0.3**
* [feature]  The version schema has changed. A field with the current version number is stored in the Version table. Change logs are no longer stored in the file.
* [bug]  Migration options (e.g., fonts, value lists, accounts) were not properly inheriting from the migration settings.
* [bug]  Modified auth string in HTTP module to account for a space or other special character in a username or password. 

**Version 2.0.2**
* [bug]  Added validation to require a saved folder name when specifying a custom wait interval.
* [bug]  Server version wasn't being saved during scheduled migrations, which could case scheduled migrations to fail.
* [bug]  Fixed issue where migration JSON could not be copied to clipboard.
* [bug]  Removing the last selected item in pickers (e.g., file, server) wasn't properly clearing the selection.

**Version 2.0.1**
* [feature]  Minor UI enhancements (e.g. new record buttons, email settings) 
* [feature]  Otto Migrator 2 requires at least Otto v2.4.3 to be installed. 
* [bug]  Fixed an infinite loop with scheduled migrations
* [bug]  Authentication to FMS would fail when a server was set to connect via HTTP, and the error message incorrectly said the scheduled script failed.
* [bug]  Some functions failed because the protocol was hard-coded to use https
* [bug]  Post-migration scripts fail to run for scheduled migrations

**Version 2.0.0**
* [feature]  Otto Migrator 2 requires at least Otto v2.3.0 to be installed. 
* [feature]  Supports multiple destination servers
* [feature]  Removed Project table/schema. Projects turned out to be unnecessary. We added a client field for users that manage migrations for multiple clients. 
* [feature]  Servers can be associated with multiple migrations
* [feature]  Removed support for Admin API V1 (trial has ended). Updated UI to show compatibility of scheduled migrations and post-migration scripts requiring FMS 18+.
* [feature]  The interface has been refreshed
* [feature]  Supports saving copy/clone to folder before migration. Used for migrating to multiple destinations or wait intervals exceeding 120 seconds. 
* [feature]  Allow user to specify a wait interval. If a wait interval exceeds 120 seconds, a clone/copy will be created first in a separate process. 
* [feature]  Add script to purge historical transaction records. Schedule a script on the server to run this nightly to prevent the transaction log from getting huge.
* [feature]  Start with new server wizard on launch if no servers exist (2.0.0-5)
* [bug]  Migrations will fail if the "from" file takes longer than 120 seconds. This timeout is a limitation of the fmsadmin command, but see the feature enhancement for "wait interval" to see how you can work around the issue. 

**Version 1.4.2**
* [feature]  Scheduled migrations on FMS 17 failed to create schedule, and no error was returned to the user

**Version 1.4.1**
* [feature]  Now supports getting clone(s) from a URL

**Version 1.4.0**
* [feature]  Now supports Admin API v2 (FileMaker Server 18))
* [feature]  Removed FMS Major Version field. Getting dynamically from FMS when needed.

**Version 1.3.1**
* [feature]  Checks for minimum Otto version of 1.6.1
* [feature]  Scheduled migration wizard now specifies that it's asking for credentials in the Otto Migrator file on the destination server—folks were thinking that the password was for the file(s) being migrated.
* [bug]  When closing files on FMS, use the destination name, which may be different than the source. GH #93
* [bug]  Completion timestamp is now being set explicitly; the scheduled migration routine is looking for a value in this field, but we're no longer getting it from Otto. A change was made in Otto 1.6 that only returned the start timestamp and an elapsed time.
* [bug]  Fixed issue with migration scheduling.
* [bug]  Fixed issue with opening link to Otto migration in browser (to view migration error).

**Version 1.3.0**
* [feature]  Checks for minimum Otto version of 1.5.4 #85
* [feature]  Removed annoying field validation for unchecking secure connections. Added visual alert on layout. #82
* [feature]  Improved performance of selecting files for download; added select/clear all #81
* [feature]  Added default HTTP timeout setting and override option for migrations that have large files
* [feature]  No longer warning about missing indexes, which was fixed in the latest FM Data Migration Utility
* [feature]  Added transaction log layouts
* [feature]  Added support for Otto version 1.6.x
* [feature]  Added support for migrating from a snapshot (i.e., Saved Folder)
* [feature]  Progress bar replaces live log viewer during migration. No longer depends on timer script.
* [feature]  Migration request can be copied to the clipboard to share, run requests in Postman, or to create custom workflows from other apps
* [bug]  Fixed issue with files that start with a number #83
* [bug]  FMS version no longer pulls from host; we can't assume that OM is installed on the server performing a migration. #86
* [bug]  Fixed layout issues on MS Windows
* [bug]  We're properly handling errors during version check now

**Version 1.2.0**
* [feature]  Supports encrypted files
* [feature]  Provides a warning about possible missing indexes due to bug in FileMaker Migration tool.

**Version 1.1.0**
* [feature]  Otto Migrator has been rewritten to support transactions. Take a look at the DBTransactions table to see transaction history/results.
* [feature]  Create Migration API is now available for testing. This will allow you to create custom migration workflows from a separate module. 
* [feature]  Migrations can be scheduled using the FM Server Admin API. This file needs to be hosted on the destination server
* [feature]  Post-migration routines can be executed after a successful migration. This can be used to populate new tables/fields. 
* [feature]  Close files prior to starting migration (FMS17+)
* [feature]  Removed migration type. Migrations can be archived as necessary.
* [feature]  firstrun account changed to: firstrun (account) with no password to make it easier to access for the first time
* [feature]  improved HTTP error handling
* [feature]  History timestamps now automatically adjust for UTC offset
* [bug]  Otto Migrator now treats file names case-sensitive. Case changes can cause 1631 errors.
* [bug]  Grammar and other minor UI tweaks
* [bug]  Webviewers on Windows overlaps popovers. Hide webviewer on the progress layout when the popover is opened.

**Version 1.0.0**
* [feature]  Usability enhancements
* [feature]  Added API to add migration record
* [bug]  Much better error handling now
* [bug]  Close popover if connection to server fails after three attempts
